;##################################################################
; MenuTreeview
;##################################################################

#include MenuTreeview.h

#IF STRINGS UNICODE
	S=2
#ELSE
	S=1
#ENDIF

#IFDEF X64
	P=8
#ELSE
	P=4
#ENDIF

DATA SECTION
	hInstance	HANDLE		?
	hTrv		HANDLE		?
	hClipData	HANDLE		?

CODE SECTION

START:
	invoke GetModuleHandle, 0
	mov [hInstance],rax
	invoke InitCommonControls
	invoke DialogBoxParam,[hInstance],1000,0,offset DlgProc,0
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam

	cmp P[uMsg],WM_INITDIALOG
	jne >.WM_COMMAND
		invoke GetDlgItem,[hwnd],1001
		mov [hTrv],rax
		invoke SetTreeviewSampledata,[hTrv]
		jmp >.EXIT

	.WM_COMMAND
	cmp P[uMsg],WM_COMMAND
	jne >.WM_CONTEXTMENU

		jmp >.EXIT

	.WM_CONTEXTMENU
	cmp P[uMsg], WM_CONTEXTMENU
	jne >.WM_DESTROYCLIPBOARD
		invoke TVShowMenu,[hwnd],[hTrv]
		xor rax,rax
		inc rax
		ret

	.WM_DESTROYCLIPBOARD
	cmp P[uMsg], WM_DESTROYCLIPBOARD
	jne >.WM_CLOSE
		invoke GlobalFree,[hClipData]
		xor rax,rax
		inc rax
		ret

	.WM_CLOSE
	cmp P[uMsg],WM_CLOSE
	jne >.DEFPROC
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov rax,FALSE
		ret

	.EXIT

	mov rax, TRUE
	ret
ENDF

SetTreeviewSampledata FRAME hTreeview
	// This function simply sets up some sample data
	LOCAL tvins		:TVINSERTSTRUCT
	LOCAL hParent	:%HANDLE

	mov D[tvins.hParent],0
	mov D[tvins.itemex.lParam],0
	mov D[tvins.hInsertAfter],0
	mov D[tvins.itemex.mask],TVIF_TEXT + TVIF_PARAM
	push "Level 0 Root"
	pop [tvins.itemex.pszText]
	invoke SendMessage,[hTreeview],TVM_INSERTITEM,0,addr tvins
	mov [hParent],rax

	mov D[tvins.hParent],rax
	mov D[tvins.itemex.lParam],0
	mov D[tvins.hInsertAfter],0
	mov D[tvins.itemex.mask],TVIF_TEXT + TVIF_PARAM
	push "Level 1 Subitem 1"
	pop [tvins.itemex.pszText]
	invoke SendMessage,[hTreeview],TVM_INSERTITEM,0,addr tvins

	mov D[tvins.itemex.lParam],0
	mov D[tvins.hInsertAfter],0
	mov D[tvins.itemex.mask],TVIF_TEXT + TVIF_PARAM
	push "Level 1 Subitem 2"
	pop [tvins.itemex.pszText]
	invoke SendMessage,[hTreeview],TVM_INSERTITEM,0,addr tvins

	mov D[tvins.hParent],rax
	mov D[tvins.itemex.lParam],0
	mov D[tvins.hInsertAfter],0
	mov D[tvins.itemex.mask],TVIF_TEXT + TVIF_PARAM
	push "Level 2 Subitem 1"
	pop [tvins.itemex.pszText]
	invoke SendMessage,[hTreeview],TVM_INSERTITEM,0,addr tvins

	mov D[tvins.itemex.lParam],0
	mov D[tvins.hInsertAfter],0
	mov D[tvins.itemex.mask],TVIF_TEXT + TVIF_PARAM
	push "Level 2 Subitem 2"
	pop [tvins.itemex.pszText]
	invoke SendMessage,[hTreeview],TVM_INSERTITEM,0,addr tvins

	ret
endf

TVShowMenu FRAME hParent, hTreeView
	LOCAL hPopMenu  :%HANDLE
	LOCAL MCommand	:%BOOL
	LOCAL tvht		:TVHITTESTINFO
	LOCAL tvi		:TVITEM
	LOCAL pClipData	:%PTR

	invoke GetCursorPos, ADDR tvht.pt
	invoke ScreenToClient,[hParent],ADDR tvht.pt
	invoke ChildWindowFromPoint, [hParent], [tvht.pt.x], [tvht.pt.y]
	cmp rax,[hTreeView]
	jnz >>.DONE
		invoke GetCursorPos, ADDR tvht.pt
		invoke CreatePopupMenu
		mov [hPopMenu], rax
		invoke AppendMenu, [hPopMenu], MF_STRING, 100, OFFSET szCopyM
		invoke AppendMenu, [hPopMenu], MF_STRING, 101, OFFSET szPasteM
		invoke TrackPopupMenu, [hPopMenu], TPM_LEFTALIGN + TPM_RETURNCMD,\
				[tvht.pt.x], [tvht.pt.y], NULL, [hTreeView], NULL
		mov [MCommand],eax
		invoke ScreenToClient, [hTreeView], ADDR tvht.pt
		mov D[tvht.flags],TVHT_ONITEM
		invoke SendMessage, [hTreeView], TVM_HITTEST, 0, ADDR tvht
		mov rax,[tvht.hItem]
		or rax,rax
		js >>.DONE
		cmp D[MCommand],100
		jnz >>L1
			mov [tvi.hItem], rax
			invoke OpenClipboard, [hParent]
			or rax,rax
			jz >>.DONE
				invoke EmptyClipboard
				invoke GlobalAlloc,GMEM_MOVEABLE + GMEM_ZEROINIT,4096
				mov [hClipData],rax
				invoke GlobalLock,[hClipData]
				mov [tvi.pszText], rax
				mov rax,[tvht.hItem]
				mov [tvi.hItem],rax
				mov D[tvi.mask], TVIF_TEXT
				mov D[tvi.cchTextMax], 4095
				invoke SendMessage, [hTreeView], TVM_GETITEM, 0, ADDR tvi
				invoke GlobalUnlock,[hClipData]
				invoke SetClipboardData, CF_TEXT, [hClipData]
				invoke CloseClipboard
				jmp >>.DONE

		L1:
		cmp D[MCommand],101
		jnz >>.DONE
			mov [tvi.hItem], rax
			mov D[tvi.mask], TVIF_TEXT
			invoke IsClipboardFormatAvailable, CF_TEXT
			or rax,rax
			jz >P2
				invoke OpenClipboard, [hParent]
				or rax,rax
				jz >P2
					invoke GetClipboardData, CF_TEXT
					or rax,rax
					jz >P1
						push rax
						invoke GlobalLock,rax
						mov [tvi.pszText], rax
						invoke SendMessage, [hTreeView], TVM_SETITEM, 0, ADDR tvi
						pop rax
						invoke GlobalUnlock,rax
					P1:
					invoke CloseClipboard
			P2:
			invoke DestroyMenu, [hPopMenu]

	.DONE
	ret
	szCopyM: db "Copy",0
	szPasteM: db "Paste",0
ENDF

